#!/bin/bash

set -x

application=_compiled/bin/canblaster

# Reset to BL
usb_sendhex -d 0x1669:0x1023 -r # Fails if we're already in bootloader
#sleep 2

arm-none-eabi-objcopy --output-target=binary -S $application $application.bin || exit 1

vectors_addr="$(arm-none-eabi-nm $application | sed -n -e 's/\([^ ]*\) [^ ] _vectors/\1/p')"

if [ "$vectors_addr" = a0000000 ] ; then
echo Application runs from SDRAM "$vectors_addr"

# Run binary from SDRAM
usb_sendhex -w -d 0xdead:0x2263 -t 1 -s 0xA0000000 -f binary $application.bin

usb_sendhex -d 0xdead:0x2263 -g `usb_sendhex -d 0xdead:0x2263 -s 0xA0000004 -l 4 -t 1 -u -f dump - | sed -n -e 's/^.*:\(..\) \(..\) \(..\) \(..\) */0x\4\3\2\1/p'`  # FIXME: broken pipe yo-ho

else
echo Application runs from FLASH APP "$vectors_addr"

# Erase Flash
usb_sendhex -w -d 0xdead:0x2263 -s 0x09000 -l 0x77000 -e
sleep 2

usb_sendhex -d 0xdead:0x2263 -s 0x09000 -f binary $application.bin

usb_sendhex -d 0xdead:0x2263 -r

fi

# Send binary
#usb_sendhex -w -d 0xdead:0x2263 -t 1 -s 0xA0000000 -f binary rocon-sdram.bin
#sleep 2

# Run binary
#usb_sendhex -d 0xdead:0x2263 -g `usb_sendhex -d 0xdead:0x2263 -s 0xA0000004 -l 4 -t 1 -u -f dump - | sed -n -e 's/^.*:\(..\) \(..\) \(..\) \(..\) */0x\4\3\2\1/p'`  # FIXME: broken pipe yo-ho
sleep 2

# Upload FPGA
#usb_sendhex -w -d 0x1669:0x1023 -t 1 -s 0xA1C00000 -f binary lx-rocon.pkg
#sleep 2

# Configure FPGA
#usb_sendhex -d 0x1669:0x1023 -c 0xF000

# Upload firmware
#usb_sendhex -w -d 0x1669:0x1023 -t 1 -s 0xA1C00000 -f binary fw_lxmaster.bin
#usb_sendhex -d 0x1669:0x1023 -c 0xF024 -a `stat -L -c %s fw_lxmaster.bin`

# Enable IRC
#usb_sendhex -d 0x1669:0x1023 -c 0xF011 -a 0

# Configure LX Master
#usb_sendhex -d 0x1669:0x1023 -c 0xF023 -a 0

# Enable LX Master
#usb_sendhex -d 0x1669:0x1023 -c 0xF021 -a 0

# Upload Tumbl firmware
#usb_sendhex -d 0x1669:0x1023 -c 0xF100 -a 0x0001
#usb_sendhex -d 0x1669:0x1023 -t 3 -s 0x00000000 -f binary tumbl-imem.bin
#usb_sendhex -d 0x1669:0x1023 -t 3 -s 0x00001000 -f binary tumbl-dmem.bin
#usb_sendhex -d 0x1669:0x1023 -c 0xF100 -a 0x0000
